﻿Imports System.Text

Public Module Main

    Public Class AppContext
        Inherits ApplicationContext

        Private WithEvents Tray As NotifyIcon
        Private WithEvents MainMenu As ContextMenuStrip
        Private WithEvents mnuExit As ToolStripMenuItem
        Private WithEvents Timer As Timer

        Public Sub New()
            'Initialize the menus
            mnuExit = New ToolStripMenuItem("Exit")
            MainMenu = New ContextMenuStrip
            MainMenu.Items.AddRange(New ToolStripItem() {mnuExit})

            'Initialize the tray
            Tray = New NotifyIcon
            Tray.Icon = My.Resources.TrayIcon
            Tray.ContextMenuStrip = MainMenu
            REM            Tray.Text = "Cam menu enabler"

            'Initialize the timer
            Timer = New Timer
            Timer.Interval = 500
            Timer.Start()

            'Display
            Tray.Visible = True
        End Sub

        Private Sub AppContext_ThreadExit(ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles Me.ThreadExit
            'Guarantees that the icon will not linger.
            Tray.Visible = False
        End Sub

        Private Sub mnuExit_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles mnuExit.Click
            ExitApplication()
        End Sub

        Private Sub myTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles Timer.Tick
            'Enum cam windows
            Dim hwnd = FindWindow("DlgGroupChat Window Class", vbNullString)
            Dim dwThreadID As ULong = GetWindowThreadProcessId(hwnd)
            EnumThreadWindows(dwThreadID, AddressOf EnumCamWindows, Nothing)
        End Sub

    End Class

    Function EnumWTL_BitmapButtonWithText(ByVal hwnd As IntPtr, ByRef lParam As IntPtr) As Boolean
        Dim sb As New StringBuilder(64)
        If GetClassName(hwnd, sb, sb.Capacity) = 0 Then Return True
        If sb.ToString() = "WTL_BitmapButtonWithText" Then
            Dim style As Long = GetWindowLong(hwnd, GWL_STYLE)
            If (style And WS_DISABLED) <> 0 Then
                Dim err As Integer = GetLastError()
                SetWindowLong(hwnd, GWL_STYLE, style And (Not WS_DISABLED))
            End If
            Return False
        End If
        Return True
    End Function

    Function EnumCamWindows(ByVal hwnd As IntPtr, ByVal lParam As Object) As Boolean
        Dim sb As New StringBuilder(64)
        If GetClassName(hwnd, sb, sb.Capacity) = 0 Then Return True
        If sb.ToString() = "DlgVideoViewer" Then
            EnumChildWindows(hwnd, AddressOf EnumWTL_BitmapButtonWithText, Nothing)
        End If
        Return True
    End Function

    Sub ExitApplication()
        Application.Exit()
    End Sub

    Dim mutex As Threading.Mutex

    Sub Main()
        Dim created As Boolean = False
        mutex = New Threading.Mutex(True, "1319e092-ea76-4e0e-88f9-77fd1a4ff014", created)
        If created Then
            Application.EnableVisualStyles()
            Application.Run(New AppContext)
        End If
    End Sub

End Module
