﻿Imports System.Text
Imports System.Runtime.InteropServices

Module Windows

    Public Delegate Function EnumWChildindowaProc(ByVal Handle As IntPtr, ByRef Parameter As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    Public Declare Auto Function EnumChildWindows Lib "User32.dll" _
           (ByVal hwnd As IntPtr, ByVal Callback As EnumWChildindowaProc, ByRef lParam As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean

    Public Declare Auto Function RealGetWindowClass Lib "User32.dll" _
        (ByVal hwnd As IntPtr, ByVal pszType As StringBuilder, ByVal cchType As UInteger) As Integer

    Public Delegate Function WNDENUMPROC(ByVal hwnd As IntPtr, ByVal lParam As Object) As Boolean

    Public Declare Auto Function EnumWindows Lib "user32.dll" _
        (ByVal callBack As WNDENUMPROC, ByVal lParam As Object) As Boolean

    Public Declare Auto Function EnumThreadWindows Lib "user32.dll" _
        (ByVal dwThreadId As Integer, ByVal lpfn As WNDENUMPROC, ByRef lParam As Object) As Boolean

    Public Declare Auto Function GetClassName Lib "User32.dll" _
        (hWnd As IntPtr, lpClassName As StringBuilder, ByVal nMaxCount As UInteger) As Integer

    Public Declare Auto Function FindWindow Lib "User32.dll" _
        (ByVal lpszClass As String, ByVal lpszWindow As String) As IntPtr

    Public Declare Auto Function FindWindowEx Lib "User32.dll" _
        (hwndParent As IntPtr, hwndChildAfter As IntPtr, ByVal lpszClass As String, ByVal lpszWindow As String) As IntPtr

    Public Declare Auto Function GetWindow Lib "User32.dll" _
        (hWnd As Integer, uCmd As UInteger) As Integer

    Public Declare Auto Function GetWindowThreadProcessId Lib "User32.dll" _
        (ByVal hWnd As IntPtr, Optional ByRef lpdwProcessId As ULong = Nothing) As Integer

    Public Declare Auto Function SendMessage Lib "User32.dll" _
        (hWnd As Integer, uCmd As UInteger, wParam As UInteger, lParam As UInteger) As Integer

    Public Declare Auto Function SendMessageString Lib "user32.dll" _
        (hWnd As Integer, uCmd As UInteger, wParam As Integer, ByVal lParam As StringBuilder) As Integer

    Public Const EM_GETLINECOUNT = 1
    Public Const EM_LINELENGTH = 2
    Public Const EM_GETLINE = 3

    Public Declare Auto Function GetAtomName Lib "Kernel32.dll" _
        (ByVal nAtom As IntPtr, ByVal lpBuffer As StringBuilder, ByVal nSize As Integer) As UInteger

    Public Declare Auto Sub SetLastError Lib "Kernel32.dll" (ByVal err As Integer)
    Public Declare Auto Function GetLastError Lib "Kernel32.dll" () As Integer

    Public Delegate Function PROPENUMPROC(ByVal hwnd As IntPtr, ByVal lpszString As IntPtr, ByVal hData As IntPtr) As Boolean
    Public Declare Auto Function EnumProps Lib "user32.dll" _
        (ByVal hWnd As IntPtr, ByVal lpEnumFunc As PROPENUMPROC) As Boolean

    Public Declare Auto Function IsWindowVisible Lib "user32.dll" _
        (ByVal hwnd As IntPtr) As Boolean

    Public Declare Auto Sub Sleep Lib "Kernel32.dll" (dwMilliseconds As ULong)

    Public Declare Auto Function EnableWindow Lib "User32.dll" _
        (hWnd As ULong, bEnable As Boolean) As Boolean


    Public Function LOWORD(ByVal val As IntPtr) As UInt16
        Return val.ToInt32() And &HFFFF
    End Function

    Public Function MAKEINTATOM(ByVal val As UInt16) As IntPtr
        Return val
    End Function

    Public Declare Auto Function GetWindowLong Lib "user32.dll" _
        (ByVal hWnd As IntPtr, ByVal nIndex As Integer) As Long

    Public Declare Auto Function SetWindowLong Lib "User32.dll" _
        (hWnd As IntPtr, nIndex As Integer, dwNewLong As Long) As Long

    Public Const GWL_EXSTYLE = -20
    Public Const GWL_HINSTANCE = -6
    Public Const GWL_HWNDPARENT = -8
    Public Const GWL_ID = -12
    Public Const GWL_STYLE = -16
    Public Const GWL_USERDATA = -21
    Public Const GWL_WNDPROC = -4
    Public Const DWL_MSGRESULT = 0
    Public ReadOnly Property DWL_DLGPROC As Integer
        Get
            Return DWL_MSGRESULT + IntPtr.Size
        End Get
    End Property
    Public ReadOnly Property DWL_USER As Integer
        Get
            Return GWL_WNDPROC + IntPtr.Size
        End Get
    End Property

    ' extended windows styles
    Public Const WS_EX_ACCEPTFILES = &H10
    Public Const WS_EX_APPWINDOW = &H40000
    Public Const WS_EX_CLIENTEDGE = &H200
    Public Const WS_EX_COMPOSITED = &H2000000
    Public Const WS_EX_CONTEXTHELP = &H400
    Public Const WS_EX_CONTROLPARENT = &H10000
    Public Const WS_EX_DLGMODALFRAME = &H1
    Public Const WS_EX_LAYERED = &H80000
    Public Const WS_EX_LAYOUTRTL = &H400000
    Public Const WS_EX_LEFT = &H0
    Public Const WS_EX_LEFTSCROLLBAR = &H4000
    Public Const WS_EX_LTRREADING = &H0
    Public Const WS_EX_MDICHILD = &H40
    Public Const WS_EX_NOACTIVATE = &H8000000
    Public Const WS_EX_NOINHERITLAYOUT = &H100000
    Public Const WS_EX_NOPARENTNOTIFY = &H4
    Public Const WS_EX_OVERLAPPEDWINDOW = WS_EX_WINDOWEDGE Or WS_EX_CLIENTEDGE
    Public Const WS_EX_PALETTEWINDOW = WS_EX_WINDOWEDGE Or WS_EX_TOOLWINDOW Or WS_EX_TOPMOST
    Public Const WS_EX_RIGHT = &H1000
    Public Const WS_EX_RIGHTSCROLLBAR = &H0
    Public Const WS_EX_RTLREADING = &H2000
    Public Const WS_EX_STATICEDGE = &H20000
    Public Const WS_EX_TOOLWINDOW = &H80
    Public Const WS_EX_TOPMOST = &H8
    Public Const WS_EX_TRANSPARENT = &H20
    Public Const WS_EX_WINDOWEDGE = &H100

    ' window styles
    Public Const WS_BORDER = &H800000
    Public Const WS_CAPTION = &HC00000
    Public Const WS_CHILD = &H40000000
    Public Const WS_CHILDWINDOW = &H40000000
    Public Const WS_CLIPCHILDREN = &H2000000
    Public Const WS_CLIPSIBLINGS = &H4000000
    Public Const WS_DISABLED = &H8000000
    Public Const WS_DLGFRAME = &H400000
    Public Const WS_GROUP = &H20000
    Public Const WS_HSCROLL = &H100000
    Public Const WS_ICONIC = &H20000000
    Public Const WS_MAXIMIZE = &H1000000
    Public Const WS_MAXIMIZEBOX = &H10000
    Public Const WS_MINIMIZE = &H20000000
    Public Const WS_MINIMIZEBOX = &H20000
    Public Const WS_OVERLAPPED = &H0
    Public Const WS_OVERLAPPEDWINDOW = WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX
    Public Const WS_POPUP = &H80000000
    Public Const WS_POPUPWINDOW = WS_POPUP Or WS_BORDER Or WS_SYSMENU
    Public Const WS_SIZEBOX = &H40000
    Public Const WS_SYSMENU = &H80000
    Public Const WS_TABSTOP = &H10000
    Public Const WS_THICKFRAME = &H40000
    Public Const WS_TILED = &H0
    Public Const WS_TILEDWINDOW = WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX
    Public Const WS_VISIBLE = &H10000000
    Public Const WS_VSCROLL = &H200000
End Module
